<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="../CSS and JS\style.css">
	<link rel="stylesheet" href="../CSS and JS\prism.css">
	<link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

	<title>static_cast</title>
</head>

<body>
	<h1>static_cast&lttype&gt(from)</h1>
	<a href="https://en.cppreference.com/w/cpp/language/static_cast">For mer info klikk her.</a>
	<p>
		Static_cast omgjør verdien fra en type, for eksempel double, til en verdi av en annen type, for eksempel int.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
int myInt = static_cast&ltint&gt(6.7); // myInt = 6
</code>
	</pre>
	<p>
		I eksempelet under, runder vi av pi til én desimal ved å omforme fra double til int.
		Her bruker vi at int ikke kan ha desimaler.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Runder av pi til én desimal
double pi { 3.14159 }; // pi = 3.14159
int temp = static_cast&ltint&gt( pi * 10 ); // temp = 31
pi = static_cast&ltdouble&gt( temp / 10.0 ); // pi = 3.1
</code>
	</pre>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Dette kan også gjøres mer kompakt
double pi {3.14159};
pi = static_cast&ltdouble&gt(static_cast&ltint&gt( pi * 10 ) / 10. );
</code>
	</pre>
	<p>
		Et annet eksempel på hvor det kan være nyttig med static_cast er hvis man bruker en enum class.
		I eksempelet under finner vi at mai er den 5. måneden.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Headerfil (month.hpp)

#pragma once
enum class month {
    January = 1, February, March, April, May, June, July, August, September, October, November, December
};
</code>
	</pre>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Hovedfil (main.cpp)

#include &ltiostream>
#include "month.hpp"
int main()
{
    std::cout << "May is the " << static_cast&ltint&gt(month::May) << "th month." << std::endl;
}
</code>
	</pre>

	<script src="../CSS and JS\prism.js"></script>
	<script src="../CSS and JS/copy.js"></script>
</body>

</html>